clear
load sw07measurementdata
load pmin_lbc
load startparlbc20

stobs=71; %starting at the same data as SW
x=sw07dat(stobs:end,:); %remove pre-1960 data
n=length(x);
w=2*pi*(1:1:230-stobs)'/n; %frequencies for approximate (Whittle) log likelihood
w=[w(5:155)]; %omit low frequencies

B=50000; %set number of burn-in values
N=250000; %set number of effective draws in the Markov chain
M=N+B; %total number of draws made

CH=zeros(34,M); %storage for draws
c=[0.13]; %scaling constant for covariance matrix

%%
for k=1:length(c)
    sigma=c(k)*pmhess_lbc; %proposal covariance matrix
parstart=startpar(:,10); %starting value
CH(:,1)=parstart; %initialize the mean of the proposal distribution;
rejc=zeros(M-1,1); %rejection counter storage
probac=zeros(M-1,1); %probability of acceptance
lik=zeros(M,1); 
%detflag=probac;
pflag=probac;
lik(1,1)=appll_sww(parstart,x,w);
rng(46626)
tic;
for i=2:M
    if mod(i,1000)==0
        i %display each 100th iteration
    end
    y=mvnrnd(zeros(34,1),sigma,1).' + CH(:,i-1); %draw a parameter vector with previous draw as mean
    %yy(:,i)=y; %keep draws
    %keeping var-covar matrix the same across all draws
    pflag(i-1,1)=parflag(y);
    %detflag(i-1,1)=checkdet(y);
    if pflag(i-1,1)==1
        CH(:,i)=CH(:,i-1); %keep previous draw as some parameter(s) violate bounds
        rejc(i-1,1)=1; %record rejection
        lik(i,1)=lik(i-1,1);
    %elseif detflag(i-1,1)==0
        %CH(:,i)=CH(:,i-1); %keep previous draw, since, while parameter bounds are ok, the solution 
        %is indeterminate
        %rejc(i-1,1)=1; %record rejection
        %lik(i,1)=lik(i-1,1);
    else
    u=rand(1,1); %generate uniform on (0,1)
    u=log(u);
    %Compute acceptance probability
    
    lik(i,1)=appll_sww(y,x,w); %record likelihood at the draw (diagnostic)
    
    alpha=lik(i,1) - lik(i-1,1); %ratio of densities
    
    probac(i-1,1)=alpha; %record probability of accepting (diagnostoc)
    
    if u<=alpha
        CH(:,i)=y; %accept draw
        rejc(i-1,1)=0; %record acceptance of the draw
    else
        CH(:,i)=CH(:,i-1);
        rejc(i-1,1)=1; %record rejection
        lik(i,1)=lik(i-1,1);
    end
    end
end
toc;
filename=['mcmc' '_lbcupd' num2str(c(k)*100) '_' num2str(46626)];
save(filename)
end
