%This script computes mean IRF's and the percentiles for confidence bands.
%Universal code for all mcmc results provided.
%% Parameter setup
%load results

tic;
%load mcmc_fullupd15_46626 CH B
%load mcmc_bcupd13_46626 CH B
%load mcmc_hbcupd10_46626 CH B
load mcmc_lbcupd13_46626 CH B

%or other file with mcmc results



thetas=CH(:,B+1:end);
varind=[1:7];
ind=[200:200:250000];
thetas=thetas(:,ind); %take every 200th draw
clear CH
%
order=20; %periods of IR
res1=zeros(order+1,1000,numel(varind));
res2=res1;
res3=res1;
res4=res1;
res5=res1;
res6=res1;
res7=res1;

tic;
for k=1:1000 %indexes parameter vectors
    if mod(k,100)==0
        k
    end
    for l=1:numel(varind) %indexes endogenous variables
theta=thetas(:,k);
%
cgy=theta(1);
cmaw=theta(2);
cmap=theta(3);
calfa=theta(4);
czcap=theta(5);
csadjcost=theta(6);
csigma=theta(7);
chabb=theta(8);
cfc=theta(9);
cindw=theta(10);
cprobw=theta(11);
cindp=theta(12);
cprobp=theta(13);
csigl=theta(14);
crpi=theta(15);
crdy=theta(16);
cry=theta(17);
crr=theta(18);
crhoa=theta(19);
crhob=theta(20);
crhog=theta(21);
crhoqs=theta(22);
crhoms=theta(23);
crhopinf=theta(24);
crhow=theta(25);
sigma_a=theta(26);
sigma_b=theta(27);
sigma_g=theta(28);
sigma_qs=theta(29);
sigma_m=theta(30);
sigma_pinf=theta(31);
sigma_w=theta(32);
cgamma=(theta(33)/100)+1; %note the initial parameterization as in SW Table 1a
cbeta=100/(theta(34)+100);%
ctou=0.025; %fixed parameters as in SW
cg=0.18;
clandaw=1.5;
curvp=10;
curvw=10;
%
theta0=[theta(1:32);cgamma;cbeta;ctou;cg;clandaw;curvp;curvw];
%% Set up gensys
ssdpar;
eqvarshock;
setsimsmat; %get sims representation
[T1,TC,T0,M,TZ,TY,GEV,RC] = gensys(GAM0,GAM1,CS,PSI,PPI);
%%



matB=eye(neq);
matA=matB(18:24,:);
A0=matA;
A1=A0*0;
A1(:,18:20)=-A0(:,18:20); %select appropriate first differences
A1(:,23)=-A0(:,23);

%%
IMP=impulse(T0,T1,A0,A1,order);
% Variable index: 1:consumption; 2:investment; 3:output; 4: labor
%                   5: inflation; 6: wage; 7: interest rate
%   Shock index:    1: total factor productivity
%                   2: risk premium
%                   3: spending
%                   4: investment
%                   5: monetary policy
%                   6: price markup 
%                   7: wage markup
% 
v_index=varind(l);

s_index=1;
result1=zeros(order+1,1);

for j=1:order+1
result1(j)=IMP(v_index,(j-1)*rows(IMP)+s_index);
end
%%%

s_index=2;
result2=zeros(order+1,1);

for j=1:order+1
result2(j)=IMP(v_index,(j-1)*rows(IMP)+s_index);
end

s_index=3;
result3=zeros(order+1,1);


for j=1:order+1
result3(j)=IMP(v_index,(j-1)*rows(IMP)+s_index);
end


s_index=4;
result4=zeros(order+1,1);

for j=1:order+1
result4(j)=IMP(v_index,(j-1)*rows(IMP)+s_index);
end

s_index=5;
result5=zeros(order+1,1);

for j=1:order+1
result5(j)=IMP(v_index,(j-1)*rows(IMP)+s_index);
end

s_index=6;
result6=zeros(order+1,1);

for j=1:order+1
result6(j)=IMP(v_index,(j-1)*rows(IMP)+s_index);
end

s_index=7;
result7=zeros(order+1,1);

for j=1:order+1
result7(j)=IMP(v_index,(j-1)*rows(IMP)+s_index);
end


res1(:,k,l)=result1;
res2(:,k,l)=result2;
res3(:,k,l)=result3;
res4(:,k,l)=result4;
res5(:,k,l)=result5;
res6(:,k,l)=result6;
res7(:,k,l)=result7;

    end

end
toc;

pc_irf1=zeros(21,2,numel(varind)); %get 5th and 95 percentiles of IRF distribution
pc_irf2=pc_irf1;
pc_irf3=pc_irf1;
pc_irf4=pc_irf1;
pc_irf5=pc_irf1;
pc_irf6=pc_irf1;
pc_irf7=pc_irf1;
for j=1:numel(varind)
for i=1:21
    
    pc_irf1(i,:,j)=prctile(sort(res1(i,:,j)'),[5,95]);
    pc_irf2(i,:,j)=prctile(sort(res2(i,:,j)'),[5,95]);
    pc_irf3(i,:,j)=prctile(sort(res3(i,:,j)'),[5,95]);
    pc_irf4(i,:,j)=prctile(sort(res4(i,:,j)'),[5,95]);
    pc_irf5(i,:,j)=prctile(sort(res5(i,:,j)'),[5,95]);
    pc_irf6(i,:,j)=prctile(sort(res6(i,:,j)'),[5,95]);
    pc_irf7(i,:,j)=prctile(sort(res7(i,:,j)'),[5,95]);

end
end
%%
%% Parameter setup


%get mean impulse responses from the posterior
for j=1:numel(varind)
for i=1:21
    
    mmres1(i,j)=mean((res1(i,:,j)'))';
    mmres2(i,j)=mean((res2(i,:,j)'))';
    mmres3(i,j)=mean((res3(i,:,j)'))';
    mmres4(i,j)=mean((res4(i,:,j)'))';
    mmres5(i,j)=mean((res5(i,:,j)'))';
    mmres6(i,j)=mean((res6(i,:,j)'))';
    mmres7(i,j)=mean((res7(i,:,j)'))';

end
end
save IRF_lbc_mup
toc;
%or save IRF_lbc_m etc.