%This script extracts IRF and confidence bands and produces figures
%3(a)-3(g)
x=[0:1:20]; %x-axis label
shockind=[1:7]';
ymf=zeros(3,21,7);
ylf=ymf;
yhf=ymf;
ymb=ymf;
ylb=ymf;
yhb=ymf;
for kk=1:7 %loop over variables
    
    for jj=1:7 %loop over shocks
        
load IRF_full_spec_mup
m=['mmres' num2str(shockind(jj)) '(:,' num2str(kk) ')']; %string for mean irf
ymf(kk,:,jj)=eval(m); %store mean irf
h=['pc_irf' num2str(shockind(jj)) '(:,2,' num2str(kk) ')']; %string for mean irf
yhf(kk,:,jj)=eval(h); %store high bound
l=['pc_irf' num2str(shockind(jj)) '(:,1,' num2str(kk) ')']; %string for mean irf
ylf(kk,:,jj)=eval(l); %store low bound
clearvars -except y* shockind x jj kk
load IRF_lbc_mup
m=['mmres' num2str(shockind(jj)) '(:,' num2str(kk) ')']; %string for mean irf
ymb(kk,:,jj)=eval(m); %store mean irf
h=['pc_irf' num2str(shockind(jj)) '(:,2,' num2str(kk) ')']; %string for mean irf
yhb(kk,:,jj)=eval(h);
l=['pc_irf' num2str(shockind(jj)) '(:,1,' num2str(kk) ')']; %string for mean irf
ylb(kk,:,jj)=eval(l);
clearvars -except y* x shockind jj kk
    end
end

save irf_plot_lbcmup
%%
v1='Consumption';
v2='Investment';
v3='Output';
v4='Labor hours';
v5='Inflation';
v6='Wage';
v7='Interest rate';

s1='productivity shock';
s2='risk premium shock';
s3='exogenous spending shock';
s4='investment shock';
s5= 'monetary policy shock';
s6= 'price mark-up shock'; 
s7= 'wage mark-up shock';
x=[0:1:20]; %x-axis label
%
for j=1:7 %variables
    figure(j)
    for i=1:7 %shocks

        subplot(4,2,i);
        plot(x,zeros(1,21),'-',x,ymf(j,:,i),'-',x,ymb(j,:,i),'--','Color','k','LineWidth',1);
       
        hold on
ciplot(ylf(j,:,i),yhf(j,:,i),x,[0.5,0.5,0.5]);
alpha(0.5)
ciplot(ylb(j,:,i),yhb(j,:,i),x,'k');
alpha(0.5)
title([ eval(['v' num2str(j)]) ' to a ' eval(['s' num2str(i)])])
%ct = camtarget;
%camtarget([ct(1)+0.001*ct(1) ct(2)+0.001 ct(3)]);
    end
   
end
 legend('Posterior mean of impulse response at full spectrum estimates','Posterior mean of impulse response with low frequencies omitted','90% posterior interval at full spectrum estimates', '90% posterior interval with low frequencies omitted')
plot(x,zeros(1,21),'-','Color','k','LineWidth',1);
