function X = specsol_sw(theta0,w)
%Function to compute simple transpose of vec(ftheta) to check spectra
%along the nonidentification curve
% //now obtain the spectral density matrix under the given parameter values
cgy=theta0(1);
cmaw=theta0(2);
cmap=theta0(3);
calfa=theta0(4);
czcap=theta0(5);
csadjcost=theta0(6);
csigma=theta0(7);
chabb=theta0(8);
cfc=theta0(9);
cindw=theta0(10);
cprobw=theta0(11);
cindp=theta0(12);
cprobp=theta0(13);
csigl=theta0(14);
crpi=theta0(15);
crdy=theta0(16);
cry=theta0(17);
crr=theta0(18);
crhoa=theta0(19);
crhob=theta0(20);
crhog=theta0(21);
crhoqs=theta0(22);
crhoms=theta0(23);
crhopinf=theta0(24);
crhow=theta0(25);
sigma_a=theta0(26);
sigma_b=theta0(27);
sigma_g=theta0(28);
sigma_qs=theta0(29);
sigma_m=theta0(30);
sigma_pinf=theta0(31);
sigma_w=theta0(32);
cgamma=theta0(33);
cbeta=theta0(34);
ctou=theta0(35);
cg=theta0(36);
clandaw=theta0(37);
curvp=theta0(38);
curvw=theta0(39);

%compute parameters derived from steady state
ssdpar; %see ssdpar.m
%% 
% % number equations
eqvarshock;  %see eqvarshock.m

%%
setsimsmat; %get sims representation
%% call gensys
[T1,TC,T0,M,TZ,TY,GEV,RC] = gensys(GAM0,GAM1,CS,PSI,PPI);

spec=zeros(length(w),49);
matB=eye(neq);
matA=matB(18:24,:);
i=1;
while i<=length(w); %compute spectrum (see gmatrix.m for details)
exe=exp(-1i*w(i));
matA(:,[18:20,23])=matA(:,[18:20,23])*(1-exe);
fact1=matA*((eye(neq) - T1*exe)\T0);
ftheta=(1/(2*pi))*(fact1*fact1'); %compute spectrum using representation (4) in the paper
spec(i,:)=ftheta(:).'; %take vec(ftheta).' to compactly fit values into 1 row
matA=matB(18:24,:); %restore initial A
i=i+1;
end;
X=spec;
end