function [COH CI]= cohers(x1,x2,weight)
%Computes absolute coherence between x1 and x2 using smoothed periodogram
%method with weights 'weight'
f11=smoothper(x1,weight,0);
f11=f11(:,1); %smoothed spectrum of the first

f22=smoothper(x2,weight,0);
f22=f22(:,1); %smoothed spectrum of the second

f12=smoothcrper([x1,x2],weight); %smoothed cross-periodograms
f21=smoothcrper([x2,x1],weight);
c12=0.5*(f12+f21); %cospectrum
q12=1i*0.5*(f12-f21); %phase spectrum

COH= sqrt(c12.^2+q12.^2)./sqrt(f11.*f22);
CI=[COH,COH]+[-1.96*sqrt(sum(weight.^2))*(1/sqrt(2))*(1-COH.^2),1.96*sqrt(sum(weight.^2))*(1/sqrt(2))*(1-COH.^2)]; %95% ci
% for i=1:length(COH)
%     if CI(i,1)<0
%         CI(i,1)=0;
%     end
% end
end