function X = itpercr(w,x)
%Computes the periodogram at frequencies w using data x,
%where x is a vector with time series.
%Intended for use with bivariate time series
s=size(x);
T=s(1); %determine sample size
t=kron(ones(1,1),[1:T]'); %time indices 1 to T

for i=1:length(w)
wt1(i,1)=(1/(sqrt(2*pi*T)))*sum(x(:,1).*exp(-1i*w(i)*t)); %Fourier transform
wt2(i,1)=(1/(sqrt(2*pi*T)))*sum(x(:,2).*exp(-1i*w(i)*t)); %Fourier transform
end

X=wt1.*conj(wt2); %complex conjugate product
end