function X = itperv(w,x)
%Computes the periodogram at frequency w using data x,
%where x is a vector with time series.
s=size(x);
T=s(1); %determine sample size

t=[1:T]'; %time indices 1 to T
for j=1:length(w)
wt(j,1)=(1/(sqrt(2*pi*T)))*sum(x.*exp(-1i*w(j)*t)).'; %Fourier transform
end
X=wt.*conj(wt); %complex conjugate product
end