function X = smoothcrper(x,weight)

%Smoothed cross-periodogram estimate
%Sample size should be even

s=size(x);
T=s(1); %sample size
ny=s(2);
w=[0:1:floor(T/2)]'*2*pi/T;
l=numel(weight); %length of window
m=(l-1)/2; %number of one-sided weights (m)
per=itpercr(w,x); %compute raw periodogram
for i=1:m
    loper(i,1)=per(i+1,1);
    upper(i,1)=per(end-i,1);
end
loper=flipud(loper); %flip lower added periodogram values
per=[loper;per;upper];
%per(m+1)=interp1([-2*pi/T;2*pi/T],[per(m),per(m+2)],[0]); %interpolate frequency zero between adjacent values
per(m+1)=real(per(m+2)*weight(m+1) +2*sum(weight(m+2:end).*per(m+3:2*m+2))); %Brockwell Davis estimate
X(1,1)=per(m+1); %frequency zero
for j=2:floor(T/2)+1
    X(j,1)=sum(per(j:2*m+j).*weight);
end

    

    
end