function [X CI]= smoothper(x,weight,scale)
%scale=0 for level, log otherwise
%Smoothed periodogram estimate
%Sample size should be even

s=size(x);
T=s(1); %sample size
w=[0:1:floor(T/2)]'*2*pi/T;
l=numel(weight); %length of window
m=(l-1)/2; %number of one-sided weights (m)
per=itperv(w,x); %compute raw periodogram
for i=1:m
    loper(i,1)=per(i+1,1);
    upper(i,1)=per(end-i,1);
end
loper=flipud(loper); %flip lower added periodogram values
per=[loper;per;upper];
%per(m+1)=interp1([-2*pi/T;2*pi/T],[per(m),per(m+2)],[0]); %interpolate frequency zero between adjacent values
per(m+1)=per(m+2)*weight(m+1) +2*sum(weight(m+2:end).*per(m+3:2*m+2)); %Brockwell Davis estimate
X(1,1)=per(m+1); %frequency zero
for j=2:floor(T/2)+1
    X(j,1)=sum(per(j:2*m+j).*weight);
end
if scale==0
CI(:,1)=X(:,1)-X(:,1)*1.96*sqrt(sum(weight.^2)); %confidence bounds for level
CI(:,2)=X(:,1)+X(:,1)*1.96*sqrt(sum(weight.^2));
else
    X(:,1)=log(X(:,1));
    CI(:,1)=X(:,1)-1.96*sqrt(sum(weight.^2)); %confidence bounds for log
    CI(:,2)=X(:,1)+1.96*sqrt(sum(weight.^2));
    

    
end