%% Load parameters
%The notation used is mostly preserved from SW(2007) Dynare code
ctou=.025;    %the depreciation rate, delta
clandaw=1.5;  %lambda_w, the steady state markup in the labor market
cg=0.18;      %g_y, the exogenous spending-GDP ratio
curvp=10;     %eps_p, see equ.10 in the notes
curvw=10;     %eps_w, see equ 13 in the notes
calfa=.19;        %alpha
cgamma=1.0043;    %gamma
cbeta=0.99840256; %beta
csigma=1.38;     
cfc=1.6;
cgy=0.52;

csadjcost= 5.74;  
chabb=    0.71;    
cprobw=   0.70;
csigl=    1.83;
cprobp=   0.66;
cindw=    0.58;
cindp=    0.24;
czcap=    0.54;
crpi=     2.04;
crr=      0.81;
cry=      0.08;
crdy=     0.22;
crhoa=    0.95;
crhob=    0.22;
crhog=    0.97;
crhoqs=   0.71;
crhoms=0.15;
crhopinf=0.89;
crhow=0.96;
cmap = 0.69;
cmaw  = 0.84;
sigma_a=0.45;
sigma_b=0.23;
sigma_g=0.53;
sigma_qs=0.45;
sigma_m=0.24;
sigma_pinf=0.14;
sigma_w=0.24;
ssdpar;
%Define theta0 (note ordering of parameters not the same as in the text of the appendix)
theta0=[cgy,cmaw,cmap,calfa,...
czcap,csadjcost,csigma,chabb,cfc,cindw,cprobw,cindp,cprobp,csigl,crpi,crdy,cry,crr,...
crhoa,crhob,crhog,crhoqs,crhoms,crhopinf,crhow,...
sigma_a,sigma_b,sigma_g,sigma_qs,sigma_m,sigma_pinf,sigma_w,cgamma, cbeta,ctou,cg,clandaw,curvp,curvw];
n=10000;
w=2*pi*(-4999:1:5000)'/n; 
%w=[w(3333:4687);w(5313:6667)]; %For identification
%from BC frequencies (6 to 32 quarters) (use with gmatsw.m or gmatsw_ss.m)
%% 2nd order properties, all observables
G=gmatsw(w,theta0,[1:7],1e-07); %takes about 5 minutes
%G=gmatsw2(w,theta0,[1:7],1e-07); %alternative code, less intuitive but
%about twce faster (exploits the symmetry of the spectrum)
%% 1 and 2nd order properties, all observables
theta0=[theta0,0.78,0.54]; %add ss parameters
G2=gmatsw_ss(w,theta0,[1:7],1e-07); %takes about 5 minutes depending on the cpu
%G2=gmatsw_ss2(w,theta0,[1:7],1e-07); %alternative code, less intuitive but
%about twce faster (exploits the symmetry of the spectrum)
%% Example: 2nd order properties, using only labor supply and inflation:
G3=gmatsw(w,theta0,[4,5],1e-07); %takes about 5 minutes
%% Non-identification subsets: second order
%The matrices corresponding to the non-identified subsets are as follows:
Gni1=G([11,39],[11,39]); 
Gni2=G([13,38],[13,38]); 
Gni3=G([6,8,33,34,35],[6,8,33,34,35]); 
%% Non-identification subsets: first and second order
%The matrices corresponding to the non-identified subsets are as follows:
Gni4=G2([11,39],[11,39]); 
Gni5=G2([13,38],[13,38]);